import os
import re
from datetime import date
# from pybank.mailer import dig_it
# from pybank._invoice import HtmlEnvelope
import yagmail
import fitz

# from mailer import dig_it
# from _invoice import HtmlEnvelope

class MySMTP(yagmail.SMTP):
    def __enter__(self):
        pass

    def __exit__(self, exc_type, exc_val, exc_tb):
        pass


to = ['andras.albert@mzk.ro', 'andras.pakai@mzk.ro', 'levente.marton@mzk.ro']
# to = ['deeejas@yandex.com']
path = 'c:/Users/Levi/Downloads/statements/'

yag = MySMTP(user={'levente.marton@mzk.ro': 'extrase@mzk.ro'}, host='192.168.201.4', port=25, smtp_starttls=True, smtp_ssl=False)

files = list(filter(lambda f: f.endswith('.pdf'), os.listdir(path)))
pdfs = sorted(files, key=lambda x: os.stat(os.path.join(path, x)).st_mtime, reverse=True)
# print(pdfs)
# chk = re.compile('[0-9]*?.pdf|printId|dok')
chks = ['Account', 'printId', 'Document_']  # 'dok'
logs = filter(lambda f: f.endswith('.log') and '_' in f, os.listdir('extrase'))

balances = {}
balance_repr = ''

for f in logs:
    with open('extrase/' + f) as log:
        lines = log.readlines()
        str_balance = lines[-1][11:]
        balance_date = lines[-1][:10]
        balance_date = date(int(balance_date[:4]), int(balance_date[5:7]), int(balance_date[-2:]))
        # balance = dig_it(str_balance)
        balance = eval(str_balance)
        # balances = {}
        balances[f] = {'balance': balance, 'date': balance_date}
        # tup_balances+=(balances,)
        # print(balance)
for k, v in balances.items():
    balance_repr += '\n{}: {:,.2f} / {:%d-%b-%Y}'.format(k, v['balance'], v['date'])

# print(balance_repr)
body = balance_repr
subject = 'end of day extras/intraday'
attachments = []
for pdf in range(3):
    ctime = os.stat(os.path.join(path + pdfs[pdf])).st_ctime  # date(2020, 8, 5)  # os.stat(os.path.join('f:/'+pdfs[pdf])).st_ctime
    # print(datetime.date.fromtimestamp(ctime))
    date_check = date.today() == date.fromtimestamp(ctime)  # ctime  # datetime.date.fromtimestamp(ctime)
    # NEW CODE FROM HERE
    for regex in chks:
        if re.match(regex, pdfs[pdf]):
            name_check = re.match(regex, pdfs[pdf])
            if date_check and name_check:
                doc = fitz.Document(os.path.join(path, pdfs[pdf]))
                page = doc.load_page(0)
                text = page.get_text()

                if 'GENIUS IMM MOD OP' in text:
                    usd = re.finditer('(?<=USD\n)[0-9,.-]*', text)
                    eur = re.finditer('(?<=EUR\n)[0-9,.-]*', text)
                    for p in eur:
                        if ',' in p.group(0):
                            eur = p.group(0)
                    for p in usd:
                        if ',' in p.group(0):
                            usd = p.group(0)
                    for_curr = '\n\nUNI-USD: {}\nUNI-EUR: {}'.format(usd.replace(',', '.'), eur.replace(',', '.'))
                    if for_curr not in body:
                        body += for_curr
                attachments.append(os.path.join(path, pdfs[pdf]))
                # print('add_attachement')
            elif name_check and not date_check:
                # env.add_to_text_body(f'\n\n{pdfs[pdf]} was not added since it is outdated.')
                body += f'\n\n{pdfs[pdf]} was not added since it is outdated.'

with open('c:/Users/levi/Downloads/neobt_forreign.txt', 'r') as neobt_forreign:
    lines = list(neobt_forreign.readlines())
    bt_eur = lines[0]
    bt_usd = lines[1]
body += '\n\n{}\n{}'.format(bt_usd, bt_eur)
os.remove('c:/Users/levi/Downloads/neobt_forreign.txt')
yag.send(to=to, subject=subject, contents=body, attachments=attachments)
