import re
import os

import keyring
import yagmail
from envelopes import Envelope
# from datetime import datetime

class MySMTP(yagmail.SMTP):
    def __enter__(self):
        pass

    def __exit__(self, exc_type, exc_val, exc_tb):
        pass


yag = MySMTP(user={'levente.marton@mzk.ro': 'bank_notifier@mzk.ro'}, host='192.168.201.4', port=25, smtp_starttls=True, smtp_ssl=False)

FR_ADDR, TO, SUBJ = 'bank_notifier@mzk.ro', ['office@mzk.ro'], 'Bank account event'

S_NAME = '192.168.201.4'
P_NUM = 25
LOG_U = 'levente.marton@mzk.ro'
PAS = keyring.get_password('yagmail', 'levente.marton@mzk.ro')
SEC = True

# TEST
# FR_ADDR, TO, SUBJ = 'bank_notifier@mzk.ro', ['deeejas@yandex.com'], 'Bank account event'
# END TEST


def mailer_details(mail_to=None, mail_from=None, mail_subj=None):
    return Envelope(mail_to, mail_from, mail_subj)


def dig_it(search_in, default=0.00, fl_point=100, pattern=r'\d+') -> float:
    if isinstance(search_in, (float, int)):
        return search_in
    elif ',' not in search_in and '.' not in search_in:
        return int(search_in)
    else:
        if ',' in search_in[-2:] or '.' in search_in[-2:]:
            search_in += '0'
        try:
            res = int(''.join(re.findall(pattern, search_in))[:-2]) + int(''.join(re.findall(pattern, search_in))[-2:]) / fl_point
            return res
        except ValueError:
            return default

class Transactions(object):
    def __init__(self, list_obj):
        self.list_object = list_obj

    def __repr__(self):
        s = ''
        for i in self.list_object:
            s += '\n' + str(i)
        try:
            return '\n\n'.join(self.list_object)  # [-2:]
        except Exception as _:
            return s

def merge_lists(list1, list2, final_list=[]) -> list:
    if len(list1) == len(list2):
        for i in range(len(list1)):
            try:
                final_list.append(list2[i])
            except IndexError:
                pass
            final_list.append(list1[i])
    else:
        for i in range(len(list2)):
            final_list.append(list2[i])
            try:
                final_list.append(list1[i])
            except IndexError:
                pass
    return final_list

def re_check(string, pattern=r'(?<=;)[A-Za-z]* [A-Za-z@:-]*_*[A-Za-z@:-]*(?=;)'):
    r = re.finditer(pattern, string)
    try:
        ret_val = next(r).group()
    except StopIteration:
        ret_val = ''
    return ret_val

def delete_cache_files(cache_folder):
    for root, _, files in os.walk(cache_folder):
        for file in files:
            file_path = os.path.join(root, file)
            os.remove(file_path)
            print(f'Deleted: {file_path}')


if __name__ == '__main__':
    print(dig_it('296049.4'))
    print('{:,.1f}'.format(dig_it('296049.4'), grouping=True))
    # print(eval('296049.4'))

# my_letter = mailer_details(TO, FR_ADDR, SUBJ)
#
# print(my_letter._subject)
# n_subj  = 'BRD'
#
# my_letter._subject = n_subj + ' ' + SUBJ
#
# print(my_letter._subject)
