'''
Created on Apr 8, 2020 @author: deeejas
'''

import logging
from logging import FileHandler
from logging import Formatter

# def logfilename(file_name=None):
#     return 'extrase/{:s}.log'.format(file_name)

# extras_log_file = logfilename()
# balance_log_file = 'extrase/br_balance.log'
def extr_logger(file_name, root=None):
    extras_logger = logging.getLogger('pybank.statements')
    extras_logger.setLevel(logging.INFO)
    extras_logger_fhandler = FileHandler('{:s}extrase/{:s}.log'.format(root, file_name))
    extras_logger_fhandler.setLevel(logging.INFO)
    extras_logger_fhandler.setFormatter(Formatter('%(asctime)s %(message)s', datefmt='%Y-%m-%d'))
    extras_logger.addHandler(extras_logger_fhandler)
    return extras_logger

def bal_logger(file_name, root=None):
    balance_logger = logging.getLogger('pybank.balance')
    balance_logger.setLevel(logging.INFO)
    balance_logger_fhandler = FileHandler('{:s}extrase/{:s}.log'.format(root, file_name))
    balance_logger_fhandler.setLevel(logging.INFO)
    balance_logger_fhandler.setFormatter(Formatter('%(asctime)s %(message)s', datefmt='%Y-%m-%d'))
    balance_logger.addHandler(balance_logger_fhandler)
    return balance_logger

if __name__ == '__main__':
    extrlogger = extr_logger('br_statements')
    extrlogger.info('date logged')
    ballogger = bal_logger('BRD')
    ballogger.info('balance')
#     print(logfilename('BRD'))
#     try:
#         assert 6 == 6
#         extras_logger.info('True')
#     except AssertionError as exc:
#         extras_logger.exception(exc)