# from datetime import datetime
from time import sleep
from selenium import webdriver
from selenium.webdriver import ChromeOptions
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.common.by import By
import selenium.webdriver.support.ui as sui


class RemoteBank(webdriver.Chrome):

    cls_chrome_options = ChromeOptions()
    cls_chrome_options.add_experimental_option('excludeSwitches', ['enable-automation', 'enable-logging'])
    cls_chrome_options.add_argument('--disable-infobars')
    cls_chrome_options.add_argument('--disable-dev-shm-usage')
    cls_chrome_options.add_argument('--no-sandbox')
    cls_chrome_options.add_argument('--disable-gpu')
    cls_chrome_options.add_argument('--ignore-certificate-errors')
    cls_chrome_options.binary_location = 'C:/Program Files/BraveSoftware/Brave-Browser/Application/brave.exe'
    u_data_dir = 'user-data-dir='
    statement_folder = 'extrase/'
    # cls_chrome_options.add_experimental_option('excludeSwitches', ['enable-logging'])
    # cls_chrome_options.add_experimental_option('useAutomationExtension', False)
    # cls_chrome_options.set_capability('acceptInsecureCerts', True)
    # cls_chrome_options.add_argument('--allow-running-insecure-content')
    # cls_chrome_options.add_argument('--ignore-ssl-errors=yes')
    # cls_chrome_options.add_argument('--ignore-certificate-errors')
    # cls_chrome_options.add_argument('user-data-dir=_bt_')

    def __init__(self, employees=None, chrome_options=cls_chrome_options):
        self.chrome_options = chrome_options
        self.employees = employees or []
        super().__init__(options=self.chrome_options)

    @classmethod
    def set_user_data_dir(cls, folder):
        cls.cls_chrome_options.add_argument(cls.u_data_dir + folder)
        cls.u_data_dir = cls.u_data_dir + folder

    @classmethod
    def set_statement_filename(cls, filename):
        cls.statement_folder = cls.statement_folder + filename

    # @classmethod
    def get_driver_version(self):
        for k, v in self.capabilities.items():
            if k == 'chrome' or k == 'browserVersion':
                if k == 'chrome':
                    print('Driver version', v['chromedriverVersion'])
                    print(end='\n' * 2)
                else:
                    print('browser version', v)
                    print(end='\n' * 2)

    def tab_load(self, nr_tabs):
        nr_tabs -= 1
        self.get('https://duckduckgo.com/?q=python&t=hf&ia=about')
        print('loading %s tabs' % (nr_tabs + 1))
        first_result = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_element(By.CLASS_NAME, 'body--serp'))
        first_link = first_result.find_element(By.TAG_NAME, 'a')
        main_window = self.current_window_handle
        self.switch_to.window(main_window)
        i = 0
        while i < nr_tabs:
            first_link.send_keys(Keys.CONTROL + Keys.RETURN)
            i += 1
            sleep(1)
        self.switch_to.window(self.window_handles[0])
        sleep(2)
